<template>
	<div>
		<b-card bg-variant="danger" v-if="!isSearchPermitted">
			Searching courses is not allowed
		</b-card>
		<div v-if="isSearchPermitted">
			<b-collapse id="colCourseSearch" v-model="course_selected_state_not">
				<b-card
					title="Select a Course from MaineStreet"
					sub-title="Enter the search parameters, click on search, then filter if desired using the table column headers"
				>
					<b-card-body class="p-0">
						<div>
							<b-form @submit.stop.prevent="searchClasses" class="mx-auto w-50">
								<b-form-group
									id="frmCampus"
									label="Campus"
									label-for="ddlCampus"
								>
									<CampusDDL
										v-model="campus"
										v-bind:populate_globally_selected_campus="
											populate_globally_selected_code
										"
									/>
								</b-form-group>
								<b-form-group
									id="frmTerm"
									label="Term"
									label-for="ddlTermSelectorSemester"
								>
									<TermSelector
										v-model="term"
										v-bind:populate_globally_selected_campus="
											populate_globally_selected_code
										"
										:allow-empty="false"
									/>
								</b-form-group>
								<b-form-group
									id="frmSubject"
									label="Subject"
									label-for="txtSubject"
									description="Searches are not case sensitive"
								>
									<b-form-input
										id="txtSubject"
										v-model="subject"
										required
										placeholder="Subject"
									></b-form-input>
								</b-form-group>
								<b-form-group
									id="frmNumber"
									label="Catalog Number"
									label-for="txtNumber"
									description="Searches use 'starts with', so searching for just 3 will return all 300 level courses. Searching for 318 will give the courses that are just 318."
								>
									<b-form-input
										id="txtNumber"
										v-model="number"
										required
										placeholder="Catalog Number"
									></b-form-input>
								</b-form-group>

								<b-button
									type="submit"
									variant="primary"
									:disabled="submit_disabled"
									>Search</b-button
								>
							</b-form>
						</div>
						<hr class="my-4" />
						<b-overlay :show="courses_fetching" rounded="sm">
							<b-table
								id="tblCourseSelector"
								ref="tblCourseSelector"
								:items="filtered"
								:fields="fields"
								striped
								small
								primary-key="code"
								:tbody-transition-props="transProps"
								selectable
								select-mode="single"
								@row-selected="rowSelected"
								:aria-hidden="courses_fetching ? 'true' : null"
							>
								<template slot="top-row" slot-scope="{ fields }">
									<td
										:class="field.class"
										v-for="field in fields"
										:key="field.key"
									>
										<label
											:for="'msCourseSearch-' + field.key"
											v-if="field.sortable"
											class="sr-only"
											>{{ field.label }}</label
										>
										<input
											:id="'msCourseSearch-' + field.key"
											v-model="filters[field.key]"
											:placeholder="field.label"
											size="10"
										/>
									</td>
								</template>
							</b-table>
							<AdminHelpTooltip
								target="tblCourseSelector"
								permissions="get:lmsCourse-byCode"
							/>
						</b-overlay>
					</b-card-body>
				</b-card>
			</b-collapse>
			<AdminHelpTooltip
				target="colCourseSearch"
				:permissions="searchPermission"
			/>
			<b-collapse id="colSelectedCourse" v-model="course_selected_state">
				<div class="jumbotron p-4">
					<div v-show="course_lms_id.length > 0">
						<b-link target="_blank" :href="course_url">
							<p class="display-3">{{ selected_course_code }}</p>
						</b-link>
					</div>
					<div v-show="course_lms_id.length === 0">
						<p class="display-3">{{ selected_course_code }}</p>
					</div>
					<b-button
						:aria-expanded="course_selected_state"
						aria-controls="colCourseSearch"
						@click="clear_selected_course"
					>
						Change Course
					</b-button>
				</div>
			</b-collapse>
			<AdminHelpTooltip
				target="colSelectedCourse"
				permissions="get:lmsCourse-byCode"
			/>
		</div>
	</div>
</template>

<script>
import { mapGetters, mapActions, mapMutations } from "vuex";

export default {
	model: {
		prop: "value",
		event: "change"
	},
	props: {
		populate_globally_selected_code: {
			type: Boolean,
			default: true
		},
		data_source: {
			type: String,
			default: "/courses/"
		}
	},
	data() {
		return {
			campus: null,
			term: "",
			filters: {
				institution: "",
				term: "",
				classNumber: "",
				isCombined: "",
				sessionCode: "",
				title: ""
			},
			transProps: {
				name: "flip-list"
			},
			fields: [
				{ key: "title", label: "Title", sortable: true },
				{ key: "code", label: "Code", sortable: true },
				{ key: "instructorNames", label: "Instructor(s)", sortable: true }
			],
			local_selected_course_code: "",
			course_lms_id: "",
			local_subject: "",
			local_number: ""
		};
	},
	computed: {
		...mapGetters({
			items: "CourseSelectorMaineStreet/coursesMS",
			selected_course_code_ms: "selected_course_code",
			global_campus: "campus",
			global_term: "term",
      courses_fetching: "CourseSelectorMaineStreet/courses_fetching",
      search_subject: "CourseSelectorMaineStreet/search_subject",
      search_number: "CourseSelectorMaineStreet/search_number",
      hasPermission: "Navbar/hasPermission",
      lms_url_for_course: "Navbar/lms_url_for_course"
    }),
		subject: {
			get() {
				return this.local_subject;
			},
			set(value) {
				this.local_subject = value;
				if (!(this.populate_globally_selected_code === false)) {
					this.set_search_subject(value);
				}
			}
		},
		number: {
			get() {
				return this.local_number;
			},
			set(value) {
				this.local_number = value;
				if (!(this.populate_globally_selected_code === false)) {
					this.set_search_number(value);
				}
			}
		},
		selected_course_code: {
			get() {
				return this.local_selected_course_code;
			},
			set(value) {
				this.local_selected_course_code = value;
				this.populate_course_lms_id();
				if (!(this.populate_globally_selected_code === false)) {
					this.set_selected_course_code_ms(value);
				}
			}
		},
		submit_disabled() {
			if (this.campus === "") {
				return true;
			}
			if (this.term === "") {
				return true;
			}
			if (this.subject === "") {
				return true;
			}

			return this.number === "";
		},
		filtered() {
			return this.items.filter(item => {
				return Object.keys(this.filters).every(key =>
					String(item[key].toLowerCase()).includes(
						this.filters[key].toLowerCase()
					)
				);
			});
		},
		course_selected_state: {
			get() {
				return this.local_selected_course_code.length > 0;
			},
			set() {}
		},
		course_selected_state_not: {
			get() {
				return !this.course_selected_state;
			},
			set() {}
		},
		course_exists_in_bs() {
			return this.bs_course_lms_id !== null;
		},
		course_url() {
			return this.lms_url_for_course(this.course_lms_id);
		},
		searchPermission() {
			if (this.data_source === "/courses/defunct/") {
				return "get:courses-defunct";
			}

			return "get:courses";
		},
		isSearchPermitted() {
			return this.hasPermission(this.searchPermission);
		}
	},
	methods: {
		...mapActions({
      get_coursesMS: "CourseSelectorMaineStreet/get_coursesMS"
    , get_course_lms_id: "CourseSelectorMaineStreet/get_course_lms_id"
    }),
		...mapMutations({set_search_subject: "CourseSelectorMaineStreet/set_search_subject", set_search_number: "CourseSelectorMaineStreet/set_search_number"}),
		...mapMutations({
			set_selected_course_code_ms: "set_selected_course_code"
		}),
		rowSelected(item) {
			if (item !== undefined && item[0] !== undefined) {
				this.set_selected_course(item[0].code);
			}
		},
		searchClasses() {
			let payload = {
				campus: this.campus,
				term: this.term,
				subject: this.subject,
				number: this.number,
				data_source: this.data_source
			};

			if (this.isSearchPermitted) {
				this.get_coursesMS(payload);
			}
		},
		set_selected_course(code) {
			this.local_selected_course_code = code;
			if (!(this.populate_globally_selected_code === false)) {
				this.selected_course_code = code;
			} else {
				this.populate_course_lms_id();
			}
			this.$emit("change", this.local_selected_course_code);
		},
		clear_selected_course() {
			if (this.local_selected_course_code.length > 0) {
				this.searchClasses();
			}

			this.local_selected_course_code = "";
			if (!(this.populate_globally_selected_code === false)) {
				this.selected_course_code = "";
			}
			this.$refs.tblCourseSelector.clearSelected();
			this.$emit("change", this.local_selected_course_code);
		},
		populate_course_lms_id() {
			if (
				this.selected_course_code.length > 0 &&
				this.hasPermission("get:lmsCourse-byCode")
			) {
				let vThis = this;
				this.get_course_lms_id(this.selected_course_code)
					.then(function(course_lms_id) {
						vThis.course_lms_id = course_lms_id;
					})
					.catch(function() {
						vThis.course_lms_id = "";
					});
			}
		}
	},

	mounted() {
		if (!(this.populate_globally_selected_code === false)) {
			this.local_selected_course_code = this.selected_course_code_ms;
		}
		this.populate_course_lms_id();
		this.campus = this.global_campus;
		this.term = this.global_term;
		this.local_subject = this.search_subject;
		this.local_number = this.search_number;
	}
};
</script>
